#include "owl.h"
#include <stdlib.h>
#include <string.h>

int owl_messagelist_create(owl_messagelist *ml) {
  owl_list_create(&(ml->list));
  return(0);
}

int owl_messagelist_get_size(owl_messagelist *ml) {
  return(owl_list_get_size(&(ml->list)));
}

int owl_messagelist_get_numdeleted(owl_messagelist *ml) {
  /* this is different now */
  return(0);
}

void *owl_messagelist_get_element(owl_messagelist *ml, int n) {
  return(owl_list_get_element(&(ml->list), n));
}

int owl_messagelist_append_element(owl_messagelist *ml, void *element) {
  return(owl_list_append_element(&(ml->list), element));
}

/* do we really still want this? */
int owl_messagelist_delete_element(owl_messagelist *ml, int n) {
  /* mark a message as deleted */
  owl_message_mark_delete(owl_list_get_element(&(ml->list), n));
  return(0);
}

int owl_messagelist_undelete_element(owl_messagelist *ml, int n) {
  /* mark a message as deleted */
  owl_message_unmark_delete(owl_list_get_element(&(ml->list), n));
  return(0);
}

int owl_messagelist_expunge(owl_messagelist *ml) {
  /* expunge deleted messages */
  int i, j;
  owl_list newlist;
  owl_message *m;

  owl_list_create(&newlist);
  /* copy the list without messages marked as deleted */
  j=owl_list_get_size(&(ml->list));
  for (i=0; i<j; i++) {
    m=owl_list_get_element(&(ml->list), i);
    if (owl_message_is_delete(m)) {
      owl_message_free(m);
    } else {
      owl_list_append_element(&newlist, m);
    }
  }

  owl_list_free_simple(&(ml->list));
  
  memcpy(&(ml->list), &newlist, sizeof(owl_list));

  return(0);
}
